<template>
  <div class="s1">
    <div class="treecont">
      <v-text-field v-model="search" label="查找文件夹" hide-details clearable class="mt-0 pt-0"></v-text-field>
      <v-treeview
        :items="itemsa"
        activatable
        color="red"
        :search="search"
        item-key="path"
        @input="emit_change"
        @update:active="click($event)"
        hoverable
        dense
        open-all
      >
        <template v-slot:prepend="{ item, open }">
          <v-icon v-if="item.type === 'dir'">{{ open ? "mdi-folder-open" : "mdi-folder" }}</v-icon>
          <v-icon v-else>{{filetype[item.type]}}</v-icon>
        </template>
        <template v-slot:append="{ item }">
          <!-- 项目文件夹下拉菜单(只有增文件(夹)) -->
          <v-menu v-if="item.id === 1">
            <template v-slot:activator="{ on, attrs }">
              <v-btn icon v-bind="attrs" v-on="on" small>
                <v-icon>mdi-menu</v-icon>
              </v-btn>
            </template>

            <v-list color="pink lighten-1" dark>
              <v-list-item @click.stop="dialog_newFile=true">新建文件</v-list-item>
              <v-dialog v-model="dialog_newFile" width="500">
                <v-card>
                  <v-card-title>
                    <span class="headline">新建文件</span>
                  </v-card-title>
                  <v-card-text>
                    <v-text-field
                      dense
                      label="输入文件名"
                      color="pink"
                      v-model.trim="newFileName"
                      clearable
                      counter
                      maxlength="30"
                      :rules="[() => !!newFileName || '不得为空'] "
                      required
                    ></v-text-field>
                  </v-card-text>
                  <v-divider></v-divider>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="dialog_newFile = false">取消</v-btn>
                    <v-btn color="primary" text @click="newFile(item)">确认</v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
              <v-list-item @click.stop="dialog_newFolder = true">新建文件夹</v-list-item>
              <v-dialog v-model="dialog_newFolder" width="500">
                <v-card>
                  <v-card-title>
                    <span class="headline">新建文件夹</span>
                  </v-card-title>
                  <v-card-text>
                    <v-text-field
                      dense
                      label="输入文件夹名"
                      color="pink"
                      v-model.trim="newFolderName"
                      clearable
                      counter
                      maxlength="30"
                      :rules="[() => !!newFolderName || '不得为空'] "
                      required
                    ></v-text-field>
                  </v-card-text>
                  <v-divider></v-divider>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="dialog_newFolder = false">取消</v-btn>
                    <v-btn color="primary" text @click="newFolder(item)">确认</v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
            </v-list>
          </v-menu>
          <!-- 文件夹下拉菜单 -->
          <v-menu v-else-if="item.type === 'dir'">
            <template v-slot:activator="{ on, attrs }">
              <v-btn icon v-bind="attrs" v-on="on" small>
                <v-icon>mdi-menu</v-icon>
              </v-btn>
            </template>

            <v-list color="pink lighten-1" dark>
              <v-list-item @click.stop="dialog_newFile = true">新建文件</v-list-item>
              <v-dialog v-model="dialog_newFile" width="500">
                <v-card>
                  <v-card-title>
                    <span class="headline">新建文件</span>
                  </v-card-title>
                  <v-card-text>
                    <v-text-field
                      dense
                      label="输入文件名"
                      color="pink"
                      v-model.trim="newFileName"
                      clearable
                      counter
                      maxlength="30"
                      :rules="[() => !!newFileName || '不得为空'] "
                      required
                    ></v-text-field>
                  </v-card-text>
                  <v-divider></v-divider>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="dialog_newFile = false">取消</v-btn>
                    <v-btn color="primary" text @click="newFile(item)">确认</v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
              <v-list-item @click.stop="dialog_newFolder = true">新建文件夹</v-list-item>
              <v-dialog v-model="dialog_newFolder" width="500">
                <v-card>
                  <v-card-title>
                    <span class="headline">新建文件夹</span>
                  </v-card-title>
                  <v-card-text>
                    <v-text-field
                      dense
                      label="输入文件夹名"
                      color="pink"
                      v-model.trim="newFolderName"
                      clearable
                      counter
                      maxlength="30"
                      :rules="[() => !!newFolderName || '不得为空'] "
                      required
                    ></v-text-field>
                  </v-card-text>
                  <v-divider></v-divider>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="dialog_newFolder = false">取消</v-btn>
                    <v-btn color="primary" text @click="newFolder(item)">确认</v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
              <v-list-item @click.stop="dialog_rename = true ">重命名</v-list-item>
              <v-dialog v-model="dialog_rename" width="500">
                <v-card>
                  <v-card-title>
                    <span class="headline">重命名</span>
                  </v-card-title>
                  <v-card-text>
                    <v-text-field
                      dense
                      label="输入新名字"
                      color="pink"
                      v-model.trim="newName"
                      clearable
                      counter
                      maxlength="30"
                      :rules="[() => !!newName || '不得为空'] "
                      required
                    ></v-text-field>
                  </v-card-text>
                  <v-divider></v-divider>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="dialog_rename = false">取消</v-btn>
                    <v-btn color="primary" text @click="renameNode(item)">确认</v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
              <v-list-item @click="delNode(item)">
                <v-list-item-title>删除</v-list-item-title>
              </v-list-item>
            </v-list>
          </v-menu>
          <!-- 文件下拉菜单 -->
          <v-menu v-else>
            <template v-slot:activator="{ on, attrs }">
              <v-btn icon v-bind="attrs" v-on="on" small>
                <v-icon>mdi-menu</v-icon>
              </v-btn>
            </template>

            <v-list color="pink lighten-1" dark>
              <v-list-item @click.stop="dialog_rename = true ">重命名</v-list-item>
              <v-dialog v-model="dialog_rename" width="500">
                <v-card>
                  <v-card-title>
                    <span class="headline">重命名</span>
                  </v-card-title>
                  <v-card-text>
                    <v-text-field
                      dense
                      label="输入新名字"
                      color="pink"
                      v-model.trim="newName"
                      clearable
                      counter
                      maxlength="30"
                      :rules="[() => !!newName || '不得为空'] "
                      required
                    ></v-text-field>
                  </v-card-text>
                  <v-divider></v-divider>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" text @click="dialog_rename = false;">取消</v-btn>
                    <v-btn color="primary" text @click="renameNode(item)">确认</v-btn>
                  </v-card-actions>
                </v-card>
              </v-dialog>
              <v-list-item @click="delNode(item)">删除</v-list-item>
            </v-list>
          </v-menu>
        </template>
      </v-treeview>
    </div>
  </div>
</template>

<script>
export default {
  name: "treeview",
  data: () => ({
    search: null,
    items: [],
    itemsa: [],
    chosen: "",
    projectName: "",
    contextMenuTarget: "",
    contextMenuVisible: true,
    show: true,
    newName: "",
    newFileName: "",
    newFolderName: "",
    dialog_newFile: false,
    dialog_newFolder: false,
    dialog_rename: false,
    roomId: 0,
    projectUsers: [],
    filetype: {
      none: "mdi-file",
      html: "mdi-language-html5",
      js: "mdi-language-javascript",
      ts: "mdi-language-typescript",
      json: "mdi-json",
      md: "mdi-markdown",
      pdf: "mdi-file-pdf",
      png: "mdi-file-image",
      txt: "mdi-file-document-outline",
      xls: "mdi-file-excel",
      c: "mdi-language-c",
      cpp: "mdi-language-cpp",
      java: "mdi-language-java",
      php: "mdi-language-php",
      py: "mdi-language-python",
      css: "mdi-language-css3",
      dir: "mdi-folder"
    }
  }),
  components: {},
  // watch: {
  //   items(){
  //     console.log('items更新');

  //     this.update();
  //   }
  // },
  methods: {
    toTreeData() {
      //得到路径
      for (let leaf of this.items) {
        if (leaf.type === "" || !this.filetype[leaf.type]) leaf.type = "none";
        if (!leaf.pid) leaf.path = leaf.name;
        else
          leaf.path =
            this.items.filter(x => x.id == leaf.pid)[0].path + "/" + leaf.name;
      }
      this.updateTreeData();
    },
    updateTreeData() {
      let cloneData = JSON.parse(JSON.stringify(this.items)); // 对源数据克隆
      let tree = cloneData.filter(parent => {
        //循环所有项
        let branchArr = cloneData.filter(child => {
          return parent.id == child.pid; //返回每一项的子级数组
        });
        if (branchArr.length > 0) {
          parent.children = branchArr; //如果存在子级，则给父级添加一个children属性，并赋值
        }
        return parent.pid == 0; //返回第一层
      });
      this.$set(this, "itemsa", JSON.parse(JSON.stringify(tree))); //返回树形数据
    },
    emit_change() {
      // todo: bug: 只能选择选中的第一个文件
      //this.$evtbus.$emit("CodeEdit.FileHasSelected", this.projectName, this.sel[0]);
    },
    click(event) {
      this.chosen = event[0];
      console.log(event);
      if(this.items.filter(i=>i.path===this.chosen)[0].type!=="dir"){
        this.$evtbus.$emit(
          "CodeEdit.FileHasSelected",
          this.projectName,
          event[0]
        );
      }
    },
    delNode(item) {
      this.$axios({
        method: "post",
        url: `${this.$siteConfig.apiUrl()}/projectfile`,
        data: {
          operation: item.type == "dir" ? "DelDir" : "DeleteFile",
          projectName: this.projectName,
          path: item.path
        }
      }).then(res => {
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "OK") {
            this.$evtbus.$emit("Filetree.SendUpdate", {
              roomId: this.roomId,
              projectUsers: this.projectUsers
            });
          } else if (data.status === "ERROR") {
            alert("删除错误。");
          } else if (data.status === "IsUsing") {
            alert("有成员正在编辑此文件。\n不可操作。");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    renameNode(item) {
      if (this.newName.length === 0) {
        return;
      }
      this.dialog_rename = false;
      let repath =
        item.path.substring(0, item.path.lastIndexOf("/") + 1) + this.newName;
      if (repath.length === 0 || repath.length > 30) {
        alert("新文件夹名不能为空或者大于30个字符");
        return;
      }
      this.$axios({
        method: "post",
        url: `${this.$siteConfig.apiUrl()}/projectfile`,
        data: {
          operation: "RenameFile",
          projectName: this.projectName,
          path: item.path,
          rename: repath
        }
      }).then(res => {
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "OK") {
            this.$evtbus.$emit("Filetree.SendUpdate", {
              roomId: this.roomId,
              projectUsers: this.projectUsers
            });
          } else if (data.status === "AlreadyExist") {
            alert("路径已存在。");
          } else if (data.status === "ERROR") {
            alert("重命名错误。");
          } else if (data.status === "IsUsing") {
            alert("有成员正在编辑此文件。\n不可操作。");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
      this.newName = "";
    },
    newFile(item) {
      if (this.newFileName.length === 0) {
        return;
      }
      this.dialog_newFile = false;
      this.$axios({
        method: "post",
        url: `${this.$siteConfig.apiUrl()}/projectfile`,
        data: {
          operation: "NewFile",
          projectName: this.projectName,
          path: item.path + "/" + this.newFileName
        }
      }).then(res => {
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "OK") {
            this.$evtbus.$emit("Filetree.SendUpdate", {
              roomId: this.roomId,
              projectUsers: this.projectUsers
            });
          } else if (data.status === "AlreadyExist") {
            alert("路径已存在。");
          } else if (data.status === "ERROR") {
            alert("新建文件错误。");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
      this.newFileName = "";
    },
    newFolder(item) {
      if (this.newFolderName.length === 0) {
        return;
      }
      this.dialog_newFolder = false;
      this.$axios({
        method: "post",
        url: `${this.$siteConfig.apiUrl()}/projectfile`,
        data: {
          operation: "NewDir",
          projectName: this.projectName,
          path: item.path + "/" + this.newFolderName
        }
      }).then(res => {
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "OK") {
            this.$evtbus.$emit("Filetree.SendUpdate", {
              roomId: this.roomId,
              projectUsers: this.projectUsers
            });
          } else if (data.status === "AlreadyExist") {
            alert("路径已存在。");
          } else if (data.status === "ERROR") {
            alert("新建文件夹错误。");
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
      this.newFolderName = "";
    },
    changeProject() {
      this.projectName = this.$store.getters.projectName;
      if(this.projectName === ""){
          this.items = [];
          this.toTreeData(this.items);
          return;
      }

      this.$axios({
        method: "post",
        url: `/projectfile`,
        data: {
          operation: "FileList",
          projectName: this.projectName
        }
      }).then(res => {
        console.log(res);
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "OK") {
            this.items = data.filelist;
            this.toTreeData(this.items);
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
      const self = this;
      this.$axios({
        method: "post",
        url: `/project`,
        data: {
          operation: "ProjectUsers",
          projectName: this.projectName,
          userName: this.userName
        }
      }).then(function(res) {
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "OK") {
            self.projectUsers = data.data;
            console.log(self.projectUsers);
          }
        } else {
          this.alert("连接失败。\n请检查您的网络状态。");
        }
      });
    },
    updateTree() {
      this.$axios({
        method: "post",
        url: `/projectfile`,
        data: {
          operation: "FileList",
          projectName: this.projectName
        }
      }).then(res => {
        console.log(res);
        if (res.status === 200) {
          const data = res.data;
          if (data.status === "OK") {
            this.items = data.filelist;
            this.toTreeData(this.items);
          }
        } else {
          alert("连接失败。\n请检查您的网络状态。");
        }
      });
    }
  },
  mounted: function() {
    this.items = [];
    this.itemsa = [];
    this.$evtbus.$on("projectchange", () => {
      this.changeProject();
    });
    this.$evtbus.$on("CodeEdit.RoomHasChanged", roomId => {
      this.roomId = roomId;
      console.log(roomId);
    });
    this.$evtbus.$on("Filetree.Update", () => {
      this.updateTree();
    });
  },
  computed: {}
};
</script>

<style scoped>
.s1 {
  margin-top:20px;
  padding-left: 60px;
}
.rightwrap {
  display: flex;
  justify-content: flex-end;
}
.treecont {
  height: calc(100vh - 60px - 126px);
  overflow-x: hidden;
  overflow-y: auto;
}
</style>
